;*************************************************************
; Vers 1.1    
;    -    
;************************************************************
;   Filename:           warmfloor.asm
;   Date:               januar 2006
;   Assembler:          mpasm 3.20
;   Author:             Bogdanov Andrew
;************************************************************
;  LIST   p=16C73  ; cp=off=1. 3pwrt|on=1. 2wdt|on=1. =HS   *
 __CONFIG b'00000011000010'        ;   CP on      *
;************************************************************
#include  pic73.mac ;                                     
;******************** Ports Bits ****************************
;************************************************************
;------------ Buttons -----------------------
#define  OutBt1 PORTB,4   ;                      *
#define  OutBt2 PORTB,5   ;                      *
#define  OutBt3 PORTB,6   ;                      *
#define  OutBt4 PORTB,7   ;                      *
#define  inBtB  PORTA,1   ; 4         
#define  inBtA  PORTA,2   ; 3                      
;------------  ---------------------------
#define  Beeper PORTC,2   ;
#define  OnLed  PORTA,0   ;
#define  E      PORTC,3   ; 6 -> E   Enable
#define  RW     PORTC,4   ; 5 -> WR  
#define  RS     PORTC,5   ; 4 -> RS  
;--------------------------------------------
NogDS1821  equ   0  ;   ( 1)
#define  DS1821_1    PORTC,0   ;  DS1821
#define  Rele    PORTC,1  ;
;************************************************************
;           Register Definitions  20h - 7fh
;*******   ***************************************
hFlagUni      equ 0x20    ;   
;#define  fDspBright hFlagUni,3 ; bright dsp
#define  floorOFF   hFlagUni,4 ;
keyBuf        equ  0x21   ;  
keyCount      equ  0x22   ;  
delayTemp     equ  0x23   ;
local1        equ  0x24   ;    
local2        equ  0x25   ;   BUSY dsp
local3        equ  0x26   ;    Flash
;-----   HEX -> DDS -------------------------
mDdsHex    equ   0x30    ; 
mDdsLow    equ   0x31    ; 
mDdsMid    equ   0x32    ; 
mDdsHigh   equ   0x33    ;  
wDspWait   equ   0x34  ;
;*************************************************************
;      
;*************************************************************
uTempFloor     equ   0x35  ;  
uTempDown      equ   0x36  ;  
uTempUp        equ   0x37  ;  
;************************************************************
mToDS1821      equ   0x38   ;     1
mFromDS1821    equ   0x39   ;     1
mDelay         equ   0x3A   ;    
wTEMP          equ   0x3B  ; DS1821
wlocal1        equ   0x3C  ; DS1821
wlocal2        equ   0x3D  ; DS1821
;*************************************************************
        ORG     0        ;  
; ***********************************************************
        goto    Start
; ***********************************************************
        org     4    ; 16000000/4 /128 /250 = 125 
;*************************************************************
hex:     ;  .    ASCII
;*************************************************************
        andlw   0x0f        ; max = 16 
        addwf   PC,f        ;
   dt  '0','1','2','3','4','5','6','7'
   dt  '8','9','A','B','C','D','E','F'
;*************************************************************
Start:                              ; Main Programm
;*************************************************************
            bsf         STATUS,RP0  ; c 1
            movlw       b'11111110' ;
            movwf       TRISA       ;
            movlw       b'00000000' ;
            movwf       TRISB       ;
            movlw       b'10000000' ;
            movwf       TRISC       ; C7=RX,C6=TX
            movlw       b'10000111' ; 1:256S->Presc->Tmr0,
            movwf       OPTIONR     ;
            movlw       b'00000111' ; 
            movwf       ADCON1      ;
            movlw       b'00100000' ;  
            movwf       PIE1        ; USART
            movlw       d'025'      ; =0, brg=0
            movwf       SPBRG       ; USART
            movlw       b'00100010' ;  BRGH =1 high
            movwf       TXSTA       ; USART      bit2 =0 low
            bcf         STATUS,RP0  ; c 0
;*************************************************************
            movlw       b'10011101' ;  
            movwf       ADCON0      ; ADC
            movlw       b'10010000' ;  
            movwf       RCSTA       ; USART
            movlw       b'00000000' ; (bit 5 = 0   data
            movwf       PIR1        ; USART -  !!!
            movlw       b'00000000' ; (bit 5 = 0   data
            movwf       INTCON      ; 
;-------------------------------------------------------------
        mvi    uTempUp,.26     ;  
        mvi    uTempDown,.24   ;  
        mvi    uTempFloor,.55  ;  
;        bcf    fDspBright
        bsf    floorOFF        ; 
;-------------------------------------------------------------
;        clrf   PCLATH
        bsf    OnLed
        call   InitWinstar;  
        call   OutDspTemp    ;   
;*************************************************************
BaseCuc0:   ;  
;**************************************************************
        clrf  keyCount       ;
;*************************************************************
BaseCuc:   ;  
;**************************************************************
       clrwdt                ;  WDT 
       call    KeyCPU        ;  
;---------------------------------------------------------
       cpi     keyBuf,btDown ; 
       jz      ChangeLevelMinus
       cpi     keyBuf,btUp   ; 
       jz      ChangeLevelPlus
       cpi     keyBuf,btEsc   ;  ?
       jz      0
       cpi     keyBuf,btSet  ;  ?
       jz      Onfloor
       cpi     keyBuf,btF1   ;  ?
       jz      OffLed        ; 
;       cpi     keyBuf,btLeft ;  ?
;       jz      Scena3        ; ,   
;       cpi     keyBuf,btRight;  ?
;       jz      Scena4        ; ,   
       cpi      keyBuf,btF2   ;  ?
       jz       OFfloor       ; , off
;-------------------------------------------------------------
FullEXE:
;-------------------------------------------------------------
       call    CheckTemp     ;  
       call    OutDspTemp    ;   
       goto    BaseCuc       ;  
;-------------------------------------------------------------
OffLed:    ; f1
;-------------------------------------------------------------
        bcf     OnLed
        goto    FullEXE
;-------------------------------------------------------------
Onfloor:  ; set
;-------------------------------------------------------------
        bsf     OnLed
        bsf     floorOFF      ; s
        goto    FullEXE
;-------------------------------------------------------------
OFfloor:  ; f2
;-------------------------------------------------------------
        bcf     floorOFF      ; s
        goto    FullEXE
;-------------------------------------------------------------
ChangeLevelPlus:
;-------------------------------------------------------------
       bsf     floorOFF        ; 
       cpi     uTempDown,.49
       jz      BaseCuc0
       incf    uTempDown,f        ;
       incf    uTempUp,f          ;
       goto    FullEXE
;-------------------------------------------------------------
ChangeLevelMinus:
;-------------------------------------------------------------
       bsf    floorOFF        ; 
       cpi   uTempDown,.9
       jz    BaseCuc0
       decf  uTempDown,f       ;
       decf  uTempUp,f         ;
       call  OutDspTemp    ;   
       goto  BaseCuc
;**************************************************************
;/////////////////////////////////////////////////////////
;**************************************************************
#include   warmkux.inc ;                                     *
;**************************************************************
;/////////////////////////////////////////////////////////
;**************************************************************
  End  ;    BrSoft Copyright (C) 2006 Bogdanov Andrew
;**************************************************************






